From 16fac53fb7cf23867adff8c5d1b055f321bd5e16 Mon Sep 17 00:00:00 2001
From: Konstantin Oblaukhov <oblaukhov.konstantin@gmail.com>
Date: Wed, 26 Apr 2023 17:30:05 +0700
Subject: [PATCH 11/13] FD722v5 and FD788v2 support.

---
 .../forward-passthrough-fd722.c               | 62 ++++++++++-------
 .../forward-passthrough-fd788.c               | 68 ++++++++++++-------
 2 files changed, 81 insertions(+), 49 deletions(-)

diff --git a/forward-passthrough/forward-passthrough-fd722.c b/forward-passthrough/forward-passthrough-fd722.c
index 2ff93ce..1db7cd1 100644
--- a/forward-passthrough/forward-passthrough-fd722.c
+++ b/forward-passthrough/forward-passthrough-fd722.c
@@ -37,6 +37,8 @@
 #define FD722_GENLOCK_HD_DELAY 189
 #define FD722_GENLOCK_3G_DELAY 97
 
+#define FD722_IS_VERSION_5(ver) (((ver >> 16) & 0xF) >= 6)
+
 static u32 fd722_irq_mask(struct forward_passthrough_io *io)
 {
 	return (1 << (io->in_index * 4 + 16)) | (1 << ((io->out_index - 2) * 2 + 4));
@@ -283,8 +285,9 @@ static void fd722_configure_genlock(struct forward_passthrough_io *io, bool anal
 	struct forward_passthrough_format *fmt = &io->format;
 	struct forward_pll_mode *mode;
 	FD722_Genlock gl;
-	int pll_in_freq = 0;
+	int pll_in_h_freq = 0, pll_in_p_freq = 0;
 	int i;
+	bool v5 = FD722_IS_VERSION_5(io->pass->dev->fw_version);
 
 	if (!io->configured)
 		return;
@@ -292,44 +295,57 @@ static void fd722_configure_genlock(struct forward_passthrough_io *io, bool anal
 	gl = FD722_Genlock_R(pass->dev->csr);
 
 	if (analog) {
-		pll_in_freq = fmt->pixelclock / fmt->total_width;
+		pll_in_h_freq = fmt->pixelclock / fmt->total_width;
 		gl.mode = 0;
 	} else {
 		if (io->format.pixelclock == 13500000)
-			pll_in_freq = 6750000;
+			pll_in_p_freq = v5 ? 13500000 : 6750000;
 		else
-			pll_in_freq = (int)io->format.pixelclock;
+			pll_in_p_freq = (int)io->format.pixelclock;
 		gl.mode = io->in_index ? 3 : 2;
 	}
 
-	mode = pll->ops->find_mode(pll, pll_in_freq, 0, 148500000, fmt->m);
+	mode = pll->ops->find_mode(pll, pll_in_p_freq, pll_in_h_freq, fmt->m, 148500000, fmt->m);
 	if (!mode)
 		return;
 
 	FD722_Genlock_W(pass->dev->csr, gl);
 
 	pll->ops->switch_mode(pll, mode);
-	if (!analog) {
-		// Hack to avoid PLL->IN->PLL loop stuck
-		FD722_VideoInCS cs;
-		int count = 0;
 
-		// Force Master clock
-		pll->ops->select_input(pll, 1, false, false);
+	if (v5) {
+		int input = 0;
+		if (analog)
+			input = 0;
+		else 
+			input = io->in_index ? 2 : 1;
+		pll->ops->select_input(pll, input, false, true);
 		pll->ops->calibrate(pll);
-
-		// Wait for input
-		do {
-			msleep(100);
-			cs = FD722_VideoInCS_R(pass->dev->csr, io->in_index);
-			count++;
-		} while ((!cs.modeLocked) && (count < 100));
-
-		// Switch to input clock
-		pll->ops->select_input(pll, 0, false, true);
 	} else {
-		pll->ops->select_input(pll, 0, false, true);
-		pll->ops->calibrate(pll);
+		if (!analog) {
+			// Hack to avoid PLL->IN->PLL loop stuck
+			FD722_VideoInCS cs;
+			int count = 0;
+
+			// Force Master clock
+			pll->ops->select_input(pll, 1, false, false);
+			pll->ops->calibrate(pll);
+
+			// Wait for input
+			do {
+				msleep(100);
+				cs = FD722_VideoInCS_R(
+					io->pass->dev->csr,
+					io->in_index ? 1 : 0);
+				count++;
+			} while ((!cs.modeLocked) && (count < 100));
+
+			// Switch to input clock
+			pll->ops->select_input(pll, 0, false, true);
+		} else {
+			pll->ops->select_input(pll, 0, false, true);
+			pll->ops->calibrate(pll);
+		}
 	}
 
 	sg.frameSize = fmt->total_width * fmt->total_height;
diff --git a/forward-passthrough/forward-passthrough-fd788.c b/forward-passthrough/forward-passthrough-fd788.c
index af4fcad..0ce7224 100644
--- a/forward-passthrough/forward-passthrough-fd788.c
+++ b/forward-passthrough/forward-passthrough-fd788.c
@@ -36,6 +36,8 @@
 #define FD788_GENLOCK_HD_DELAY 193
 #define FD788_GENLOCK_3G_DELAY 101
 
+#define FD788_IS_VERSION_2(ver) (((ver >> 24) & 0xF) >= 2)
+
 static u32 fd788_irq_mask(struct forward_passthrough_io *io)
 {
 	return (1 << (io->in_index * 3)) | (1 << (io->out_index * 3));
@@ -253,7 +255,7 @@ static void fd788_configure_io(struct forward_passthrough_io *io)
 }
 
 static void fd788_configure_genlock(struct forward_passthrough_io *io, bool analog)
-{
+{	
 	struct forward_passthrough *pass = io->pass;
 	struct forward_pll *pll = pass->dev->pll;
 	FD788_SyncGenerator sg = { 0 };
@@ -261,8 +263,9 @@ static void fd788_configure_genlock(struct forward_passthrough_io *io, bool anal
 	struct forward_passthrough_format *fmt = &io->format;
 	struct forward_pll_mode *mode;
 	FD788_Genlock gl;
-	int pll_in_freq = 0;
+	int pll_in_h_freq = 0, pll_in_p_freq = 0;
 	int i;
+	bool v2 = FD788_IS_VERSION_2(io->pass->dev->fw_version);
 
 	if (!io->configured)
 		return;
@@ -270,44 +273,57 @@ static void fd788_configure_genlock(struct forward_passthrough_io *io, bool anal
 	gl = FD788_Genlock_R(pass->dev->csr);
 
 	if (analog) {
-		pll_in_freq = fmt->pixelclock / fmt->total_width;
+		pll_in_h_freq = fmt->pixelclock / fmt->total_width;
 		gl.mode = 0;
 	} else {
 		if (io->format.pixelclock == 13500000)
-			pll_in_freq = 6750000;
+			pll_in_p_freq = v2 ? 13500000 : 6750000;
 		else
-			pll_in_freq = (int)io->format.pixelclock;
+			pll_in_p_freq = (int)io->format.pixelclock;
 		gl.mode = io->in_index ? 3 : 2;
 	}
 
-	mode = pll->ops->find_mode(pll, pll_in_freq, 0, 148500000, fmt->m);
+	mode = pll->ops->find_mode(pll, pll_in_p_freq, pll_in_h_freq, fmt->m, 148500000, fmt->m);
 	if (!mode)
 		return;
 
 	FD788_Genlock_W(pass->dev->csr, gl);
 
 	pll->ops->switch_mode(pll, mode);
-	if (!analog) {
-		// Hack to avoid PLL->IN->PLL loop stuck
-		FD788_VideoInCS cs;
-		int count = 0;
 
-		// Force Master clock
-		pll->ops->select_input(pll, 1, false, false);
+	if (v2) {
+		int input = 0;
+		if (analog)
+			input = 0;
+		else 
+			input = io->in_index ? 2 : 1;
+		pll->ops->select_input(pll, input, false, true);
 		pll->ops->calibrate(pll);
-
-		// Wait for input
-		do {
-			msleep(100);
-			cs = FD788_VideoInCS_R(pass->dev->csr, io->in_index);
-			count++;
-		} while ((!cs.modeLocked) && (count < 100));
-
-		// Switch to input clock
-		pll->ops->select_input(pll, 0, false, true);
 	} else {
-		pll->ops->select_input(pll, 0, false, true);
-		pll->ops->calibrate(pll);
+		if (!analog) {
+			// Hack to avoid PLL->IN->PLL loop stuck
+			FD788_VideoInCS cs;
+			int count = 0;
+
+			// Force Master clock
+			pll->ops->select_input(pll, 1, false, false);
+			pll->ops->calibrate(pll);
+
+			// Wait for input
+			do {
+				msleep(100);
+				cs = FD788_VideoInCS_R(
+					io->pass->dev->csr,
+					io->in_index ? 1 : 0);
+				count++;
+			} while ((!cs.modeLocked) && (count < 100));
+
+			// Switch to input clock
+			pll->ops->select_input(pll, 0, false, true);
+		} else {
+			pll->ops->select_input(pll, 0, false, true);
+			pll->ops->calibrate(pll);
+		}
 	}
 
 	sg.frameSize = fmt->total_width * fmt->total_height;
@@ -330,10 +346,10 @@ static void fd788_configure_genlock(struct forward_passthrough_io *io, bool anal
 
 	for (i = 0; i < pass->ops->num_io; i++) {
 		struct forward_passthrough_io *o = &pass->io[i];
-		FD788_VideoOutCS cs = FD788_VideoOutCS_R(pass->dev->csr, o->out_index);
+		FD788_VideoOutCS cs = FD788_VideoOutCS_R(pass->dev->csr, (o->out_index - 2));
 		cs.syncSource = 0;
 		cs.freeRunning = 0;
-		FD788_VideoOutCS_W(pass->dev->csr, o->out_index, cs);
+		FD788_VideoOutCS_W(pass->dev->csr, (o->out_index - 2), cs);
 	}
 }
 
-- 
2.39.1


